/*

*/
#include <windows.h>
#include <math.h>
#include "glut.h"
#include "glui.h"

#define N 250
#define PI 3.14159265
double circleX[N], circleY[N], squareX[N], squareY[N];

/* GLUT callback function prototypes */
void display(void);
void reshape(int, int);
void slider(float);

int windowHeight;         // this is set by the glut reshape() callback function
int windowWidth;          // this is set by the glut reshape() callback function

#define sliderInit 0.0
float sliderValue = sliderInit;  // this is set by the glui slider() callback function

int main(int argc, char** argv)
{
   int i;
   int window;
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);  // glui needs double buffering!
   // specify the screen window
   glutInitWindowSize(500,520);       // width, height (in pixels)
   glutInitWindowPosition(100,150);   // left, top (in pixels)
   window = glutCreateWindow("Random Homotopy");
   glutDisplayFunc(display);
   glutReshapeFunc(reshape);
   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-2.0, 2.0, -2.0, 2.0); /* viewing volume */
   glMatrixMode(GL_MODELVIEW);

   // parent window, x, y, width, height, initial value, callback function
   gluiHorizontalSlider(window, 10, 0, -10, 20, sliderInit, slider);

   glClearColor(1.0, 1.0, 1.0, 0.0);
   glLineWidth(1.0);

   srand( GetTickCount() );

   for (i = 0; i < N; i++)  // compute random verticies
   {
      circleX[i] = 2-4*(rand()%100)/100.0;  // between -2 and 2
      circleY[i] = 2-4*(rand()%100)/100.0;
      squareX[i] = 2-4*(rand()%100)/100.0;
      squareY[i] = 2-4*(rand()%100)/100.0;
   }
/*
   // print out the random vertices
   for (i = 0; i < N; i++)  // compute random verticies
   {
      printf("circleX[%d] = %f, circleY[%d] = %f\n", i, circleX[i], i, circleY[i]);
      printf("squareX[%d] = %f, squareY[%d] = %f\n", i, squareX[i], i, squareY[i]);
   }
*/
   glutMainLoop( );

   return 0;
}//main()


void display(void)
{
   int i;
   double X, Y;
   float t = sliderValue;

   // specify the viewport
   glViewport( 0,  0, windowWidth, windowHeight-20); // left, bottom, width, height (in pixels)

   glClear( GL_COLOR_BUFFER_BIT );

/*
   // show the "homotopy line" between two vertices
   glColor3f(0.0f, 1.0f, 0.0f);
   glBegin(GL_LINES);
      for(i = 0; i < N; i++)
      {
         glVertex2f(circleX[i], circleY[i]);
         glVertex2f(squareX[i], squareY[i]);
      }
   glEnd();
*/
   glColor3f(0.0f, 0.0f, 1.0f);
   glBegin(GL_LINE_STRIP);
      for(i = 0; i < N; i++)
      {
         X = (1-t)*circleX[i]+t*squareX[i];
         Y = (1-t)*circleY[i]+t*squareY[i];
         glVertex2f(X, Y);
      }
   glEnd();

   glutSwapBuffers();  // glui needs double buffering!
}


/* The reshape() callback function */
void reshape(int width, int height)
{
   windowWidth  = width;
   windowHeight = height;

   printf("We got a \"reshape(%d, %d)\" event\n", width, height);

   gluiReshape(width, height);  // notice the difference here
}//reshape()


/* glui slider callback function */
void slider(float value)
{
   sliderValue = value;

   printf("We got a \"slider(%f)\" event\n", value);

   glutPostRedisplay();  // notice the difference here
}//slider()